// $Id: datastrg.cpp 356 2015-09-20 09:58:50Z you $
/*
 * Copyright (c) 2007-2015 akamoz.jp
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <akamoz-data.h>

namespace akamoz {

DataStorage::~DataStorage()
{
}

int DataStorage::putwordLE(WORD w)
{
	if (putbyte(w & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	if (putbyte((w >> 8) & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	return 0;
}

int DataStorage::putwordBE(WORD w)
{
	if (putbyte((w >> 8) & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	if (putbyte(w & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	return 0;
}

int DataStorage::putdwordLE(DWORD dw)
{
	if (putbyte(dw & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	if (putbyte((dw >> 8) & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	if (putbyte((dw >> 16) & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	if (putbyte((dw >> 24) & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	return 0;
}

int DataStorage::putdwordBE(DWORD dw)
{
	if (putbyte((dw >> 24) & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	if (putbyte((dw >> 16) & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	if (putbyte((dw >> 8) & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	if (putbyte(dw & 0xff) < 0)
		return AKAMOZ_ERR(-1);
	return 0;
}

} // namespace akamoz
