// $Id: avistreamproxy.cpp 353 2015-09-19 16:06:32Z you $
/*
 * Copyright (c) 2007-2015 akamoz.jp
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <akamoz-image.h>

namespace akamoz4 {

template <typename TC>
int AVISingleStreamProxy::setup(const TC *fname)
{
#ifdef AKAMOZ_HAVE_AVISINGLESTREAM
	{
		SwitchDebugOutput sw(nullout);
		tiny_ptr<AVISingleStream> pavi;
		pavi.reset(new AVISingleStream);
		if (pavi == NULL)
			goto L1;
		if (pavi->setup(fname) < 0)
			goto L1;
		takeover(pavi);
		return 0;
	}
L1:
#endif
#ifdef AKAMOZ_HAVE_WIN32VFW
	{
		SwitchDebugOutput sw(nullout);
		tiny_ptr<VfWSingleStream> pvfw;
		pvfw.reset(new VfWSingleStream);
		if (pvfw == NULL)
			goto L2;
		if (pvfw->setup(fname) < 0)
			goto L2;
		takeover(pvfw);
		return 0;
	}
L2:
#endif
	return AKAMOZ_ERR(-1);
}

template int AVISingleStreamProxy::setup(const char *fname);
template int AVISingleStreamProxy::setup(const wchar_t *fname);

} // namespace akamoz4
