// $Id: imgbuf-yuy2.cpp 358 2015-09-20 10:00:06Z you $
/*
 * Copyright (c) 2007-2015 akamoz.jp
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <akamoz-image.h>

namespace akamoz2 {

template <typename T>
int ImageBufferYUY2Imp::_setupPlanes(T *p)
{
	if (mimgY.setup(getWidth(), getHeight(), 8, p) < 0)
		return AKAMOZ_ERR(-1);
	if (mimgY.setPixSpan(2) < 0)
		return AKAMOZ_ERR(-1);
	if (mimgU.setup(getWidth() / 2, getHeight(), 8, p + 1) < 0)
		return AKAMOZ_ERR(-1);
	if (mimgU.setPixSpan(4) < 0)
		return AKAMOZ_ERR(-1);
	if (mimgV.setup(getWidth() / 2, getHeight(), 8, p + 3) < 0)
		return AKAMOZ_ERR(-1);
	if (mimgV.setPixSpan(4) < 0)
		return AKAMOZ_ERR(-1);
	return 0;
}

template int ImageBufferYUY2Imp::_setupPlanes(BYTE *);
template int ImageBufferYUY2Imp::_setupPlanes(const BYTE *);
template class ImageBufferYUVImp<ImageBufferYUY2Imp>;

}
