// $Id: akamoz-environ.h 359 2015-09-20 10:00:28Z you $
/*
 * Copyright (c) 2008-2015 akamoz.jp
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

// AKAMOZ_LINUX
// AKAMOZ_FREEBSD
// AKAMOZ_WIN32
// AKAMOZ_CYGWIN

// AKAMOZ_GCC
// AKAMOZ_MSC
// AKAMOZ_BCC

#ifndef AKAMOZ_ENVIRON_H_INCLUDED
#define AKAMOZ_ENVIRON_H_INCLUDED

// check environment macro definitions
#if defined(AKAMOZ_GCC) + defined(AKAMOZ_MSC) + defined(AKAMOZ_BCC) > 1
#error build environment macro must be defined solely.
#endif

// define default environment macros
#if defined(AKAMOZ_WIN32) + defined(AKAMOZ_FREEBSD) == 0
#define AKAMOZ_WIN32
#endif

#if defined(AKAMOZ_GCC) + defined(AKAMOZ_MSC) + defined(AKAMOZ_BCC) == 0
	#ifdef __GNUC__
	#define AKAMOZ_GCC
	#endif
#endif

// define functional macros.
#ifdef AKAMOZ_GCC
#define AKAMOZ_HAVE_LONGLONG
#endif

#ifdef AKAMOZ_MSC
#define AKAMOZ_HAVE_INT64
#endif

#ifdef AKAMOZ_WIN32
#define AKAMOZ_HAVE_WIN32FILEAPI
#define AKAMOZ_HAVE_WIN32VFW
#define AKAMOZ_HAVE_WIN32THREAD
#define AKAMOZ_HAVE_WIN32CRITSECT
#define AKAMOZ_HAVE_MSDIRECTX
#endif

#ifdef AKAMOZ_FREEBSD
#if AKAMOZ_FREEBSD < 5
#define AKAMOZ_NO_IOSFIXED
#endif
#endif

#if defined(AKAMOZ_LINUX) || defined(AKAMOZ_FREEBSD) ||defined(AKAMOZ_CYGWIN)
#define AKAMOZ_POSIX
#endif

#endif
