// $Id: parseopt2.cpp 360 2015-09-20 10:00:47Z you $
/*
 * Copyright (c) 2008-2015 akamoz.jp
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <akamoz-util.h>

namespace akamoz2 {

ParseOption::ParseOption()
{
	mpArgv = AKAMOZ_NULL;
	mpNextArg = AKAMOZ_NULL;
}

// strB
// SɈvꍇAs'\0'wB
// ts̑OɈvꍇAstɊ܂܂Ȃŏ̕wB
// ȊȌꍇNULLԂB
CCHAR *ParseOption::compare(CCHAR *s, CCHAR *t)
{
	while (*t != '\0') {
		if (*s != *t)
			return AKAMOZ_NULL;
		s++;
		t++;
	}
	return s;
}

CCHAR *ParseOption::getarg()
{
	CCHAR *p = mpNextArg;
	mpNextArg = AKAMOZ_NULL;
	if (p != AKAMOZ_NULL)
		return p;
	if (mnCnt >= mnArgc)
		return AKAMOZ_NULL;
	p = mpArgv[mnCnt];
	if (p != AKAMOZ_NULL)
		mnCnt++;
	return p;
}

// -- ͓ǂݔ΂ăIvVIB
// - ͓ǂݔ΂ɃIvVIB
// ŃG[B0ŐIB
// proc֐0ŌpA1ŏIAŃG[B
int ParseOption::parse(int argc, CCHAR * const argv[], const ParseOptionInfo *pinfo)
{
	if (argv == NULL)
		return AKAMOZ_ERR(-1);
	if (argc < 0)
		return AKAMOZ_ERR(-1);
	if (pinfo == NULL)
		return AKAMOZ_ERR(-1);
	mnArgc = argc;
	mpArgv = argv;
	mnCnt = 0;
	for (;;) {
		CCHAR *parg = getarg();
		if (parg == AKAMOZ_NULL)
			break;

		if ((parg[0] != '-') || (parg[1] == '\0')) {
			// nCtŎn܂ȂꍇAnCt1ꍇB
			setarg(parg);
			break;
		}

		// ɗ̂͐擪nCtŁA2ȏ̏ꍇB
		if ((parg[1] == '-') && (parg[2] == '\0'))
			break;	// dnCtB

		// IvVXgB
		CCHAR *pcmp = NULL;
		const ParseOptionInfo *pi;
		for (pi = pinfo; pi->pszOpt != AKAMOZ_NULL; pi++) {
			pcmp = compare(parg + 1, pi->pszOpt);
			if (pcmp != AKAMOZ_NULL) {
				// lIvV̏ꍇAOvȂ̂ŁAbreakB
				// lȂꍇ͊SvbreakB
				if (pi->bHaveValue || (*pcmp == '\0'))
					break;
			}
		}
		if (pi->pszOpt == AKAMOZ_NULL)	// vIvVȂ
			return AKAMOZ_ERR(-1);
		if (pi->bHaveValue) {
			// lIvVŁASvꍇAl͎̈B
			if (*pcmp == '\0') {
				pcmp = getarg();
				if (pcmp == NULL)
					return AKAMOZ_ERR(-1);	// lȂ
			}
		}
		else	// lȂIvV̏ꍇB
			pcmp = NULL;
		int nRet = proc(pi, pcmp);
		if (nRet < 0)
			return AKAMOZ_ERR(nRet);
		if (nRet > 0)
			break;
	}
	return 0;
}

void ParseOption::usage(std::ostream &os, const ParseOptionInfo *pinfo)
{
	os << "Options: \n  ";
	for (; pinfo->pszOpt != AKAMOZ_NULL; pinfo++) {
		if (pinfo->pcvUserData != AKAMOZ_NULL) {
			os << "-" << pinfo->pszOpt;
			if (pinfo->bHaveValue)
				os << " <arg>";
			os << "\t" << (const char *)pinfo->pcvUserData << "\n  ";
		}
	}
	os << "\n";
}

}
